import * as React from "react";
import View from "../View/index.mjs";
import { jsx } from "react/jsx-runtime";
class KeyboardAvoidingView extends React.Component {
  frame = null;
  relativeKeyboardHeight(keyboardFrame) {
    const frame = this.frame;
    if (!frame || !keyboardFrame) return 0;
    const keyboardY = keyboardFrame.screenY - (this.props.keyboardVerticalOffset || 0);
    return Math.max(frame.y + frame.height - keyboardY, 0);
  }
  onKeyboardChange(event) {}
  onLayout = event => {
    this.frame = event.nativeEvent.layout;
  };
  render() {
    const {
      /* eslint-disable */
      behavior,
      contentContainerStyle,
      keyboardVerticalOffset,
      /* eslint-enable */
      ...rest
    } = this.props;
    return /* @__PURE__ */jsx(View, {
      onLayout: this.onLayout,
      ...rest
    });
  }
}
var KeyboardAvoidingView_default = KeyboardAvoidingView;
export { KeyboardAvoidingView_default as default };